# Generated by go2rpm
%bcond_without check

# https://github.com/skynetservices/skydns
%global goipath         github.com/skynetservices/skydns
Version:                2.5.3
%global commit          94b2ea0d8bfa43395656ea94d4a6235bdda47129

%gometa

%global common_description %{expand:
DNS service discovery for etcd.}

%global golicenses      LICENSE
%global godocs          AUTHORS CONTRIBUTORS README.md

Name:           %{goname}
Release:        %autorelease
Summary:        DNS service discovery for etcd

License:        MIT
URL:            %{gourl}
Source0:        %{gosource}
Source1:        skydns.service
Source2:        skydns.conf
Source3:        skydns.socket
# Fix for new github.com/coreos/go-systemd and go.etcd.io/etcd
Patch0:         0001-Fix-for-new-github.com-coreos-go-systemd.patch
# Use new field for TLSInfo
Patch1:         Fix-TLSInfo.patch

BuildRequires:  golang(go.etcd.io/etcd/client/v2)
BuildRequires:  golang(go.etcd.io/etcd/client/v3)
BuildRequires:  golang(go.etcd.io/etcd/api/v3/mvccpb)
BuildRequires:  golang(go.etcd.io/etcd/client/pkg/transport)
BuildRequires:  golang(github.com/coreos/go-systemd/activation)
BuildRequires:  golang(github.com/miekg/dns)
BuildRequires:  golang(github.com/prometheus/client_golang/prometheus)
BuildRequires:  systemd-rpm-macros

%if %{with check}
# Tests
BuildRequires:  golang(golang.org/x/net/context)
%endif

%description
%{common_description}

%package -n skydns
Summary:        DNS service discovery for etcd

Requires:       etcd
Requires(pre):  shadow-utils
Provides:       skydns = %{version}-%{release}

%description -n skydns
%{common_description}

%gopkg

%prep
%goprep
%patch0 -p1
%patch1 -p1

%build
%gobuild -o %{gobuilddir}/bin/skydns %{goipath}

%install
%gopkginstall
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/

install -Dpm 0644 %{SOURCE1} %{buildroot}%{_unitdir}/skydns.service
install -Dpm 0644 %{SOURCE3} %{buildroot}%{_unitdir}/skydns.socket
install -dm 0755 %{buildroot}%{_sysconfdir}/skydns
install -m 644 -t %{buildroot}%{_sysconfdir}/skydns %{SOURCE2}
install -dm 0755 %{buildroot}%{_sharedstatedir}/skydns

%pre -n skydns
getent group skydns >/dev/null || groupadd -r skydns
getent passwd skydns >/dev/null || useradd -r -g skydns -d %{_sharedstatedir}/skydns \
        -s /sbin/nologin -c "Skydns user" skydns

%post -n skydns
%systemd_post skydns.service

%preun -n skydns
%systemd_preun skydns.service

%postun -n skydns
%systemd_postun skydns.service

%if %{with check}
%check
# server: needs network
%gocheck -d server
%endif

%files -n skydns
%license LICENSE
%doc AUTHORS CONTRIBUTORS README.md
%{_bindir}/*
%dir %attr(-,skydns,skydns) %{_sharedstatedir}/skydns
%{_unitdir}/skydns.service
%{_unitdir}/skydns.socket
%config(noreplace) %{_sysconfdir}/skydns

%gopkgfiles

%changelog
%autochangelog
